/*
       _ _           _ 
      | (_)         | |
   ___| |_ _   _  __| |
  / _ \ | | | | |/ _` |
 |  __/ | | |_| | (_| |
  \___|_|_|\__,_|\__,_|
                       
 
 document_item_repository.dart
                       
 This code is generated. This is read only. Don't touch!

*/

import 'package:eliud_pkg_fundamentals/model/model_export.dart';
import 'package:eliud_pkg_fundamentals/model/entity_export.dart';

import 'dart:async';
import 'package:eliud_core/tools/query/query_tools.dart';
import 'package:eliud_core/tools/common_tools.dart';
import 'package:eliud_core/core/base/repository_base.dart';

typedef DocumentItemModelTrigger = Function(List<DocumentItemModel?> list);
typedef DocumentItemChanged = Function(DocumentItemModel? value);
typedef DocumentItemErrorHandler = Function(dynamic o, dynamic e);

abstract class DocumentItemRepository
    extends RepositoryBase<DocumentItemModel, DocumentItemEntity> {
  @override
  Future<DocumentItemEntity> addEntity(
      String documentID, DocumentItemEntity value);
  @override
  Future<DocumentItemEntity> updateEntity(
      String documentID, DocumentItemEntity value);
  @override
  Future<DocumentItemModel> add(DocumentItemModel value);
  @override
  Future<void> delete(DocumentItemModel value);
  @override
  Future<DocumentItemModel?> get(String? id, {Function(Exception)? onError});
  @override
  Future<DocumentItemModel> update(DocumentItemModel value);

  @override
  Stream<List<DocumentItemModel?>> values(
      {String? orderBy,
      bool? descending,
      Object? startAfter,
      int? limit,
      SetLastDoc? setLastDoc,
      int? privilegeLevel,
      EliudQuery? eliudQuery});
  @override
  Stream<List<DocumentItemModel?>> valuesWithDetails(
      {String? orderBy,
      bool? descending,
      Object? startAfter,
      int? limit,
      SetLastDoc? setLastDoc,
      int? privilegeLevel,
      EliudQuery? eliudQuery});
  @override
  Future<List<DocumentItemModel?>> valuesList(
      {String? orderBy,
      bool? descending,
      Object? startAfter,
      int? limit,
      SetLastDoc? setLastDoc,
      int? privilegeLevel,
      EliudQuery? eliudQuery});
  @override
  Future<List<DocumentItemModel?>> valuesListWithDetails(
      {String? orderBy,
      bool? descending,
      Object? startAfter,
      int? limit,
      SetLastDoc? setLastDoc,
      int? privilegeLevel,
      EliudQuery? eliudQuery});

  @override
  StreamSubscription<List<DocumentItemModel?>> listen(
      DocumentItemModelTrigger trigger,
      {String? orderBy,
      bool? descending,
      Object? startAfter,
      int? limit,
      int? privilegeLevel,
      EliudQuery? eliudQuery});
  @override
  StreamSubscription<List<DocumentItemModel?>> listenWithDetails(
      DocumentItemModelTrigger trigger,
      {String? orderBy,
      bool? descending,
      Object? startAfter,
      int? limit,
      int? privilegeLevel,
      EliudQuery? eliudQuery});
  @override
  StreamSubscription<DocumentItemModel?> listenTo(
      String documentId, DocumentItemChanged changed,
      {DocumentItemErrorHandler? errorHandler});
  @override
  void flush();

  @override
  String? timeStampToString(dynamic timeStamp);

  @override
  dynamic getSubCollection(String documentId, String name);
  @override
  Future<DocumentItemModel?> changeValue(
      String documentId, String fieldName, num changeByThisValue);

  @override
  Future<void> deleteAll();
}
